' --- SUBROUTINES --- '

' ::: make long labels
subroutine sr_long_label
	smpl if id_cx = "AL"
	id_cx_long = "Albania"
	smpl if id_cx = "AT"
	id_cx_long = "Austria"
	smpl if id_cx = "BE"
	id_cx_long = "Belgium"
	smpl if id_cx = "BG"
	id_cx_long = "Bulgaria"
	smpl if id_cx = "ME"
	id_cx_long = "Montenegro"
	smpl if id_cx = "CZ"
	id_cx_long = "Czech Republic"
	smpl if id_cx = "DK"
	id_cx_long = "Denmark"
	smpl if id_cx = "EE"
	id_cx_long = "Estonia"
	smpl if id_cx = "FI"
	id_cx_long = "Finland"
	smpl if id_cx = "FR"
	id_cx_long = "France"
	smpl if id_cx = "EL"
	id_cx_long = "Greece"
	smpl if id_cx = "NL"
	id_cx_long = "Netherlands"
	smpl if id_cx = "HR"
	id_cx_long = "Croatia"
	smpl if id_cx = "IE"
	id_cx_long = "Ireland"
	smpl if id_cx = "IS"
	id_cx_long = "Iceland"
	smpl if id_cx = "IT"
	id_cx_long = "Italy"
	smpl if id_cx = "CY"
	id_cx_long = "Cyprus"
	smpl if id_cx = "LV"
	id_cx_long = "Latvia"
	smpl if id_cx = "LT"
	id_cx_long = "Lithuania"
	smpl if id_cx = "LU"
	id_cx_long = "Luxembourg"
	smpl if id_cx = "HU"
	id_cx_long = "Hungary"
	smpl if id_cx = "MT"
	id_cx_long = "Malta"
	smpl if id_cx = "NO"
	id_cx_long = "Norway"
	smpl if id_cx = "DE"
	id_cx_long = "Germany"
	smpl if id_cx = "PL"
	id_cx_long = "Poland"
	smpl if id_cx = "PT"
	id_cx_long = "Portugal"
	smpl if id_cx = "RO"
	id_cx_long = "Romania"
	smpl if id_cx = "RU"
	id_cx_long = "Russian Federation"
	smpl if id_cx = "MK"
	id_cx_long = "North Macedonia"
	smpl if id_cx = "SK"
	id_cx_long = "Slovakia"
	smpl if id_cx = "SI"
	id_cx_long = "Slovenia"
	smpl if id_cx = "RS"
	id_cx_long = "Serbia"
	smpl if id_cx = "ES"
	id_cx_long = "Spain"
	smpl if id_cx = "CH"
	id_cx_long = "Switzerland (including Liechtenstein)"
	smpl if id_cx = "SE"
	id_cx_long = "Sweden"
	smpl if id_cx = "TR"
	id_cx_long = "Turkey"
	smpl if id_cx = "UK"
	id_cx_long = "United Kingdom"
	smpl if id_cx = "UA"
	id_cx_long = "Ukraine"
	smpl if id_cx = "OTH EU"
	id_cx_long = "Other European countries"
	smpl if id_cx = "EG"
	id_cx_long = "Egypt"
	smpl if id_cx = "ZA"
	id_cx_long = "South Africa"
	smpl if id_cx = "OTH AF"
	id_cx_long = "Other African countries "
	smpl if id_cx = "CA"
	id_cx_long = "Canada"
	smpl if id_cx = "US"
	id_cx_long = "USA"
	smpl if id_cx = "OTH NA"
	id_cx_long = "Other Northern American countries"
	smpl if id_cx = "BR"
	id_cx_long = "Brazil"
	smpl if id_cx = "OTH SCA"
	id_cx_long = "Other Southern and Central American countries"
	smpl if id_cx = "BH"
	id_cx_long = "Bahrain "
	smpl if id_cx = "IN"
	id_cx_long = "India"
	smpl if id_cx = "IR"
	id_cx_long = "Iran"
	smpl if id_cx = "IL"
	id_cx_long = "Israel"
	smpl if id_cx = "JP"
	id_cx_long = "Japan"
	smpl if id_cx = "KR"
	id_cx_long = "Republic of Korea"
	smpl if id_cx = "QA"
	id_cx_long = "Qatar"
	smpl if id_cx = "CN"
	id_cx_long = "China"
	smpl if id_cx = "KW"
	id_cx_long = "Kuwait"
	smpl if id_cx = "MY"
	id_cx_long = "Malaysia"
	smpl if id_cx = "OM"
	id_cx_long = "Oman"
	smpl if id_cx = "SA"
	id_cx_long = "Saudi Arabia"
	smpl if id_cx = "AE"
	id_cx_long = "United Arab Emirates "
	smpl if id_cx = "OTH AS "
	id_cx_long = "Other Asian countries"
	smpl if id_cx = "AU"
	id_cx_long = "Australia"
	smpl if id_cx = "NZ"
	id_cx_long = "New Zealand"
	smpl if id_cx = "OCE"
	id_cx_long = "Other countries of Oceania"
	smpl if id_cx = "OTH Non-EU"
	id_cx_long = "Other non-European countries"
endsub

' ::: aggregate plot by year
subroutine sr_plot_aggregate_year(series s, string aggregate_type, string title)	
	'make contraction (aggregation type)
	%contract_type = "sum"
	
	if (aggregate_type = "mean") then
		%contract_type = "mean"	
	endif

	'make plot name
	%name  = "plot_"

	if (aggregate_type = "mean") then
		%name  = %name + "fts"
	else
		%name  = %name + "fta"		
	endif

	%name = %name + "_by_year_cx"

	'make graph of arrivals by year and country
	delete(noerr) {%name}	
	freeze({%name}) s.bar(m,contract={%contract_type},panel=stack) across(@SERIES,iscale, iscalex, nodispname, label=auto, bincount=5)  across(@YEAR,cscale, cscalex, nodispname, label=value, bincount=5)  within(ID_CX_LONG,cscale, cscalex, nodispname, label=auto, bincount=5)
	
	'set fill color
	{%name}.setelem(1) preset(1)
	
'	'force y-axis to have min-max values for each graph individually
'	{%name}.axis(left) range(minmax)
	
	'add title
    %tit = title
	{%name}.addtext(t) %tit
	
	'show all x-axis labels
	{%name}.datelabel interval(all)
	{%name}.axis(bottom) angle(90)
endsub

' ::: aggregate table by year
subroutine sr_tab_aggregate_year(series s, string aggregate_type)	
	'make contraction (aggregation type)
	%contract_type = "sum"
	
	if (aggregate_type = "mean") then
		%contract_type = "mean"	
	endif

	'make table name
	%name  = "tab_"

	if (aggregate_type = "mean") then
		%name  = "tab_average_"
	endif

	%name = %name + s.@name + "_by_year_cx"

	'make table
	delete(noerr) {%name}
	freeze({%name}) s.statby(nomean, {%contract_type}, nostd, nocount, nor, nom) id_cx_long @year
	
	'convert any 0.000000 to NA
	for !row = 8 to 68
		for !col = 2 to 16
			if (	{%name}(!row, !col) = "0.000000") then
				{%name}(!row, !col) = NA
			endif
		next
	next

	'cosmetic cleanup
	{%name}.copyrange B8 Q69 {%name} A7
	{%name}.deletecol(q) 1
	{%name}.deleterow(69) 1
endsub

' ::: annual aggregator
subroutine sr_annual_aggregator(series s, scalar is_mean, scalar is_dom, scalar is_yoy, series out)
	'make aggregator type
	%contract_type = ""

	if (is_mean = 1) then
		%contract_type = "@meansby"	
	else
		%contract_type = "@sumsby"
	endif

	'set sample (domestic vs foreign)
    if (is_dom = 1) then
        smpl if id_cx = "DDT"
    else
        smpl if id_cx = "DST"
    endif

	'aggregate
	if (is_yoy = 1) then
		out = @pcy({%contract_type}(s, @year))
	else 
		out = {%contract_type}(s, @year)
	endif
endsub

' ::: year-on-year percentage change
subroutine sr_plot(series s, scalar is_mean, scalar is_dom, scalar is_yoy, string title)	
	'make plot name
	%name  = "plot_"

    if (is_dom = 1) then
        %name = %name + "dt"
    else
        %name = %name + "ft"
    endif

	if (is_mean = 1) then
		%name  = %name + "s"
	else
		%name  = %name + "a"	
	endif

	if (is_yoy = 1) then
		%name = %name + "_yoy"
	endif

	'aggregate data
	series temp
	call sr_annual_aggregator(s, is_mean, is_dom, is_yoy, temp)

	'make aggregate plot
    if (is_dom = 1) then
        smpl if id_cx = "DDT" and @month = 1
    else
        smpl if id_cx = "DST" and @month = 1
    endif

    delete(noerr) {%name}
    freeze({%name}) temp.bar(panel=combine)

    d temp
	
	'add title
    %tit = title
	{%name}.addtext(t) %tit
	
	'force y-axis to have min-max values for each graph individually
	'{%name}.axis(left) range(minmax)

	'show all x-axis labels
	{%name}.datelabel interval(y)

	'remove legend
	{%name}.legend -display
endsub



' --- PREPARE DATA --- '
close @wf

'open workfile
wfopen "c:\users\mirza\eviews dropbox\mirza trokic\personal\eviews\ardl\blogs\ev13_nardl\workfiles\bih_tourism.wf1"

'make long labels for panel cx idx
pageselect panel_arrivals

smpl @all
alpha id_cx_long

call sr_long_label

pageselect panel_length

smpl @all
alpha id_cx_long

call sr_long_label

'convert length into length per tourist
pageselect panel_length
copy panel_arrivals\ARRIVALS * @src @date id_cx @dest @date id_cx
smpl if arrivals <> NA and length_o <> NA and arrivals <> 0 and length_o <> 0
series length = length_o / arrivals
delete(noerr) arrivals

' ::: copy tourist totals into monthly page
pageselect tourism_monthly

' domestic
%smpl = "if id_cx = " + @addquotes("ddt")

copy(smpl=%smpl) panel_arrivals\ARRIVALS * @src @date @dest @date
series dta = arrivals
delete(noerr) arrivals

copy(smpl=%smpl) panel_length\LENGTH * @src @date @dest @date
series dts = length
delete(noerr) length

' foreign
%smpl = "if id_cx = " + @addquotes("dst")

copy(smpl=%smpl) panel_arrivals\ARRIVALS * @src @date @dest @date
series fta = arrivals
delete(noerr) arrivals

copy(smpl=%smpl) panel_length\LENGTH * @src @date @dest @date
series fts = length
delete(noerr) length

' make individual ex yu republics (slovenia, croatia, montenegro, serbia,  macedonia)
%exyu = "si hr me rs mk"

for %s {%exyu}
	%smpl = "if id_cx = " + @addquotes(%s)
	
	copy(smpl=%smpl) panel_arrivals\ARRIVALS * @src @date @dest @date
	series fta_{%s} = arrivals
	delete(noerr) arrivals
	
	copy(smpl=%smpl) panel_length\LENGTH * @src @date @dest @date
	series fts_{%s} = length
	delete(noerr) length
next





'frequency conversion (monthly arrivals to quarterly arrivals via sum)
pageselect gdp_quarterly
copy(c=sum) tourism_monthly\DTA *
copy(c=sum) tourism_monthly\FTA *

'frequency conversion (quarterly gdp to monthly gdp via litterman interpolation)
pageselect tourism_monthly
delete(noerr) gdp
copy(c=dentonf) gdp_quarterly\GDP *




' --- PANEL SUMMARY STATS --- '
' ::: arrivals
pageselect panel_arrivals

'make plot of annual arrivals
call sr_plot(arrivals, 0, 0, 0, "Annual Foreign Tourist Arrivals") 'foreign
call sr_plot(arrivals, 0, 1, 0, "Annual Domestic Tourist Arrivals") 'domestic

'make plot of yoy percent change in annual arrivals
call sr_plot(arrivals, 0, 0, 1, "YOY Percent Change in Foreign Tourist Arrivals") 'foreign
call sr_plot(arrivals, 0, 1, 1, "YOY Percent Change in Domestic Tourist Arrivals") 'domestic


'summarize annual arrivals by country
smpl if id_cx <> "DDT" and id_cx <> "DST" 'remove DDT and DST from sample as these are total domestic and foreign arrivals, respectively

call sr_tab_aggregate_year(arrivals, "sum") 'table
call sr_plot_aggregate_year(arrivals, "sum", "Annual Foreign Tourist Arrivals by Country") 'plot

'compare annual arrivals between domestic and foreign tourists
smpl if (id_cx = "DDT" or id_cx = "DST")

series dfta

call sr_annual_aggregator(arrivals, 0, 0, 0,  dfta) 'foreign
call sr_annual_aggregator(arrivals, 0, 1, 0,  dfta) 'domestic

smpl if (id_cx = "DDT" or id_cx = "DST") and @month = 1

%name = "plot_dfta"

delete(noerr) {%name}
freeze({%name}) dfta.bar(panel=combine)

{%name}.addtext(t) "Domestic vs. Foreign Annual Tourist Arrivals"
{%name}.datelabel interval(y)
{%name}.setelem(1) legend("Domestic")
{%name}.setelem(2) legend("Foreign")


'compare seasonality between domestic and foreign tourists
smpl if (id_cx = "DDT" or id_cx = "DST")

%name = "plot_dfta_seas"

delete(noerr) {%name}
freeze({%name}) arrivals.line(panel=combine)

{%name}.datelabel interval(quarter, 2, 1) format("Mon YYYY") span(on)
{%name}.options gridcust(quarter,1)

{%name}.addtext(t) "Domestic vs. Foreign Tourist Arrivals Time Series"
{%name}.setelem(1) legend("Domestic")
{%name}.setelem(2) legend("Foreign")


'compare yoy percent change in arrivals between domestic and foreign tourists
series dfta_yoypc

call sr_annual_aggregator(arrivals, 0, 0, 1,  dfta_yoypc) 'foreign
call sr_annual_aggregator(arrivals, 0, 1, 1,  dfta_yoypc) 'domestic

smpl if (id_cx = "DDT" or id_cx = "DST") and @month = 1

%name = "plot_dfta_yoypc"

delete(noerr) {%name}
freeze({%name}) dfta_yoypc.bar(panel=combine)

{%name}.addtext(t) "Domestic vs. Foreign Year-on-Year Percent Change in Tourist Arrivals"
{%name}.datelabel interval(y)
{%name}.setelem(1) legend("Domestic")
{%name}.setelem(2) legend("Foreign")



' ::: length of stay
pageselect panel_length


'make plot of annual duration of stay
call sr_plot(length, 1, 0, 0, "Average Annual Foreign Tourist Length of Stay") 'foreign
call sr_plot(length, 1, 1, 0, "Average Annual Domestic Tourist Length of Stay") 'domestic

'make plot of yoy percent change in annual arrivals
call sr_plot(length, 1, 0, 1, "YOY Percent Change in Average Annual Foreign Tourist Length of Stay") 'foreign
call sr_plot(length, 1, 1, 1, "YOY Percent Change in Average Annual Domestic Tourist Length of Stay") 'domestic

'summarize average length of stay by country
smpl if id_cx <> "DDT" and id_cx <> "DST" 'remove DDT and DST from sample as these are total domestic and foreign arrivals, respectively

call sr_tab_aggregate_year(length, "mean") 'table
call sr_plot_aggregate_year(length, "mean", "Average Annual Length of Stay by Country") 'plot

'compare legth of stay between domestic and foreign tourists
series dfts

call sr_annual_aggregator(length, 1, 0, 0,  dfts) 'foreign
call sr_annual_aggregator(length, 1, 1, 0,  dfts) 'domestic

smpl if (id_cx = "DDT" or id_cx = "DST") and @month = 1

%name = "plot_dfts"

delete(noerr) {%name}
freeze({%name}) dfts.bar(panel=combine)

{%name}.addtext(t) "Domestic vs. Foreign Average Annual Length of Stay per Tourist"
{%name}.datelabel interval(y)
{%name}.setelem(1) legend("Domestic")
{%name}.setelem(2) legend("Foreign")

'compare seasonality between domestic and foreign length of stays
smpl if (id_cx = "DDT" or id_cx = "DST")

%name = "plot_dfts_seas"

delete(noerr) {%name}
freeze({%name}) length.line(panel=combine)

{%name}.datelabel interval(quarter, 2, 1) format("Mon YYYY") span(on)
{%name}.options gridcust(quarter,1)

{%name}.addtext(t) "Domestic vs. Foreign Tourist Length of Stay Time Series"
{%name}.setelem(1) legend("Domestic")
{%name}.setelem(2) legend("Foreign")




' ::: GDP
pageselect tourism_monthly

smpl if gdp <> NA

'make monthly GDP
%name = "plot_gdp"

delete(noerr) {%name}
freeze({%name}) gdp.line

{%name}.datelabel interval(quarter, 2, 1) format("Mon YYYY") span(on)
{%name}.options gridcust(quarter,1)
{%name}.axis(b) angle(90)

{%name}.addtext(t) "Monthly GDP"

'compare standardized GDP and arrivals
group grp_temp @stdize(dta) @stdize(fta) @stdize(gdp)

%name = "plot_dfta_gdp_stdize"

delete(noerr) {%name}
freeze({%name}) grp_temp.line

{%name}.datelabel interval(quarter, 2, 1) format("Mon YYYY") span(on)
{%name}.options gridcust(quarter,1)
{%name}.axis(b) angle(90)

{%name}.addtext(t) "Standardized Monthly GDP and Tourist Arrivals"

{%name}.setelem(1) legend("Domestic Arrivals")
{%name}.setelem(2) legend("Foreign Arrivals")
{%name}.setelem(3) legend("Monthly GDP")
{%name}.setelem(3) default(7)

{%name}.legend columns(3)

delete(noerr) grp_temp


' --- ESTIMATION --- '
pageselect tourism_monthly
smpl if @year < 2020

' ::: EQ1
'estimate
equation eq1.ardl(deplags=3, reglags=3, determ=utrend, trend=ulinear) @log(gdp) @ @expand(@month, @droplast) @asy @log(dta) @log(fta) dts fts

'capture results
delete(noerr) tab_est1_output
freeze(tab_est1_output) eq1.results

'capture lag selection
delete(noerr) plot_est1_lagsel
freeze(plot_est1_lagsel) eq1.icgraph

'capture symmetry test
delete(noerr) tab_est1_symmtest
freeze(tab_est1_symmtest) eq1.symmtest

' ::: EQ2
equation eq2.ardl(deplags=3, reglags=3, determ=utrend, trend=ulinear) @log(gdp) @log(dta) dts @ @expand(@month, @droplast) @asy @log(fta) fts

'capture results
delete(noerr) tab_est2_output
freeze(tab_est2_output) eq2.results

'capture lag selection
delete(noerr) plot_est2_lagsel
freeze(plot_est2_lagsel) eq2.icgraph

'capture symmetry test
delete(noerr) tab_est2_symmtest
freeze(tab_est2_symmtest) eq2.symmtest

'do bounds test
delete(noerr) tab_est2_boundstest
freeze(tab_est2_boundstest) eq2.boundstest

'do wald test on LR distributed lag variables
delete(noerr) tab_est2_waldtest
freeze(tab_est2_waldtest) eq2.wald c(2)=0, c(3)=0, c(4)=0, c(5)=0, c(6)=0, c(7)=0

'do cointegrating relationship
delete(noerr) tab_est2_cointrel
freeze(tab_est2_cointrel) eq2.cointrel

'do dynmult DM
delete(noerr) tab_est2_dynmult_dm
freeze(tab_est2_dynmult_dm) eq2.dynmult(dmevolution) 50

'do dynmult SHOCK
delete(noerr) tab_est2_dynmult_shock
freeze(tab_est2_dynmult_shock) eq2.dynmult 50

